%%  X. Lorentz function
    function dqdt = RHT(t, q, E, B1 ,B2 ,X ,d2, d3)
    
    Q= X/2.355;
    % X.1. basic
    units = irf_units;
    mp = units.me;                  % mass
    qe = units.e * (-1);            % particle charge
    BB = B1*(-tanh((q(1)+d2)/d3)+1)*0.5+B2;
    B0 = [0, 0, BB] * 1e-9;          % nT
    EE = E*exp(-(q(1)^2)/(2*Q^2));
    E0 = [EE, 0, 0] * 1e-3;  % mV/m
    
    qeome = qe/mp;  
    
    % X.2. function
    dqdt = [q(2) ; qeome*E0(1)+qeome*q(4)*B0(3)-qeome*q(6)*B0(2) ; ...
            q(4) ; qeome*E0(2)+qeome*q(6)*B0(1)-qeome*q(2)*B0(3) ; ...
            q(6) ; qeome*E0(3)+qeome*q(2)*B0(2)-qeome*q(4)*B0(1) ];
    end