function [Xout, Yout, Zout] = background(case_number)
if          case_number == 1
X=8000;
    Q=X/2.355;
X=-13060:13060;
Y=X./2612;

Y2=6*(tanh(X./653)+1)*0.5+0.1;
Y1=0*exp(-(X.^2)/(2*Q^2));
[hAx,hLine1,hLine2]=plotyy(Y,Y1,Y,Y2);
set(hLine1,'LineWidth',3);
set(hLine2,'LineWidth',3);
xSize=1300; ySize=550;
set(gcf,'Position',[10 10 xSize ySize]);

xwidth = 0.3;         
ywidth = 0.6;


c_eval('set(gca, ''position'', [0.10 0.25 xwidth ywidth]);', 1);
set(gca,'XLim',[-5 5],'fontsize',18);
set(gca,'XTick',[-5:1:5],'fontsize',18);
set(gca,'XTickLabel',[-5:1:5],'fontsize',18);

ylabel('E (mV/m)','fontsize',16);
ylabel(hAx(2),'n(cm^-3)','fontsize',16);
xlabel('x/\rho_e','fontsize',18);
set(hAx(1),'YLim',[-5 5],'fontsize',18);
set(hAx(1),'YTick',[-5:2:5],'fontsize',18);
set(hAx(1),'YTickLabel',[-5:2:5],'fontsize',18);
set(hAx(2),'YLim',[0 8],'fontsize',18);
set(hAx(2),'YTick',[0:2:8],'fontsize',18);
set(hAx(2),'YTickLabel',[0:2:8],'fontsize',18);
legend('E','n','Location','Southeast');

text(-6/2.612-0.04,0,'o','color','r','fontsize',18)
text(-4/2.612-0.04,0,'o','color','r','fontsize',18)
text(-2/2.612-0.04,0,'o','color','r','fontsize',18)
elseif           case_number == 2
X=8000;
    Q=X/2.355;
X=-13060:13060;
Y=X./2612;

Y2=6*(tanh(X./653)+1)*0.5+0.1;
Y1=10*exp(-(X.^2)/(2*Q^2));
[hAx,hLine1,hLine2]=plotyy(Y,Y1,Y,Y2);
set(hLine1,'LineWidth',3);
set(hLine2,'LineWidth',3);
xSize=1300; ySize=550;
set(gcf,'Position',[10 10 xSize ySize]);

xwidth = 0.3;         
ywidth = 0.6;


c_eval('set(gca, ''position'', [0.10 0.25 xwidth ywidth]);', 1);

set(gca,'XLim',[-5 5],'fontsize',18);
set(gca,'XTick',[-5:1:5],'fontsize',18);
set(gca,'XTickLabel',[-5:1:5],'fontsize',18);

ylabel('E (mV/m)','fontsize',16);
ylabel(hAx(2),'n(cm^-3)','fontsize',16);
xlabel('x/\rho_e','fontsize',18);
set(hAx(1),'YLim',[0 15],'fontsize',18);
set(hAx(1),'YTick',[0:3:15],'fontsize',18);
set(hAx(1),'YTickLabel',[0:3:15],'fontsize',18);
set(hAx(2),'YLim',[0 8],'fontsize',18);
set(hAx(2),'YTick',[0:2:8],'fontsize',18);
set(hAx(2),'YTickLabel',[0:2:8],'fontsize',18);
legend('E','n','Location','East');

text(-6/2.612-0.04,7,'o','color','r','fontsize',18)
text(-4/2.612-0.04,7,'o','color','r','fontsize',18)
text(-2/2.612-0.04,7,'o','color','r','fontsize',18)
elseif           case_number == 3
X=8000;
    Q=X/2.355;
X=-26120:26120;
Y=X./2612;

Y2=6*(tanh(X./7000)+1)*0.5+0.1;
Y1=14*(-tanh((X+10000)./4000)+1)*0.5+2;
[hAx,hLine1,hLine2]=plotyy(Y,Y1,Y,Y2);
set(hLine1,'LineWidth',3);
set(hLine1,'color','g');
set(hLine2,'LineWidth',3);
xSize=1300; ySize=550;
set(gcf,'Position',[10 10 xSize ySize]);

xwidth = 0.3;         
ywidth = 0.6;


c_eval('set(gca, ''position'', [0.10 0.25 xwidth ywidth]);', 1);

set(gca,'XLim',[-10 10],'fontsize',18);
set(gca,'XTick',[-10:2:10],'fontsize',18);
set(gca,'XTickLabel',[-10:2:10],'fontsize',18);

ylabel('B (nT)','fontsize',16,'color','g');
ylabel(hAx(2),'n(cm^-3)','fontsize',16);
xlabel('x/\rho_e','fontsize',18);
set(hAx(1),'YLim',[0 20],'fontsize',18);
set(hAx(1),'YTick',[0:4:20],'fontsize',18);
set(hAx(1),'YTickLabel',[0:4:20],'fontsize',18);
set(hAx(1),'Ycolor','g')
set(hAx(2),'YLim',[0 8],'fontsize',18);
set(hAx(2),'YTick',[0:2:8],'fontsize',18);
set(hAx(2),'YTickLabel',[0:2:8],'fontsize',18);
legend('B','n','Location','East');


text(-4-0.04,10,'o','color','r','fontsize',18)
text(-2-0.04,10,'o','color','r','fontsize',18)
text(-0-0.04,10,'o','color','r','fontsize',18)
    elseif           case_number == 4
X=615;
    Q=X/2.355;
X=-1742:1742;
Y=X./871;


Y1=100*exp(-(X.^2)/(2*Q^2));
Y2=[];
for i=1:3485
Y2(i)=sum(Y1(1:3485-i))/1000;
end

[hAx,hLine1,hLine2]=plotyy(Y,Y1,Y,Y2);
set(hLine1,'LineWidth',3);
set(hLine2,'LineWidth',3);
set(hLine2,'color','k');
xSize=1300; ySize=550;
set(gcf,'Position',[10 10 xSize ySize]);

xwidth = 0.3;         
ywidth = 0.6;


c_eval('set(gca, ''position'', [0.10 0.25 xwidth ywidth]);', 1);;

set(gca,'XLim',[-2 2],'fontsize',18);
set(gca,'XTick',[-2:1:2],'fontsize',18);
set(gca,'XTickLabel',[-2:1:2],'fontsize',18);
ylabel('E (mV/m)','fontsize',16);
ylabel(hAx(2),'\phi (V)','fontsize',16);
xlabel('x/\rho_e','fontsize',18);
set(hAx(1),'YLim',[0 200],'fontsize',18);
set(hAx(1),'YTick',[0:50:200],'fontsize',18);
set(hAx(1),'YTickLabel',[0:50:200],'fontsize',18);
set(hAx(2),'YLim',[0 150],'fontsize',18);
set(hAx(2),'YTick',[0:30:150],'fontsize',18);
set(hAx(2),'YTickLabel',[0:30:150],'fontsize',18);
set(hAx(2),'Ycolor','k')
legend('E','\phi','Location','East');

%irf_legend(gca,'(c1)',[-0.15 1.03],'fontsize',20,'color','k')
text(-600/871-0.04,100,'o','color','r','fontsize',18)
text(-300/871-0.04,100,'o','color','r','fontsize',18)
text(-000/871-0.04,100,'o','color','r','fontsize',18)        
else
X=615;
    Q=X/2.355;
X=-1742:1742;
Y=X./871;


Y1=200*exp(-(X.^2)/(2*Q^2));
Y2=[];
for i=1:3485
Y2(i)=sum(Y1(1:3485-i))/1000;
end

[hAx,hLine1,hLine2]=plotyy(Y,Y1,Y,Y2);
set(hLine1,'LineWidth',3);
set(hLine2,'LineWidth',3);
set(hLine2,'color','k');
xSize=1300; ySize=550;
set(gcf,'Position',[10 10 xSize ySize]);

xwidth = 0.3;         
ywidth = 0.6;


c_eval('set(gca, ''position'', [0.10 0.25 xwidth ywidth]);', 1);

set(gca,'XLim',[-2 2],'fontsize',18);
set(gca,'XTick',[-2:1:2],'fontsize',18);
set(gca,'XTickLabel',[-2:1:2],'fontsize',18);
ylabel('E (mV/m)','fontsize',16);
ylabel(hAx(2),'\phi (V)','fontsize',16);
xlabel('x/\rho_e','fontsize',18);
set(hAx(1),'YLim',[0 200],'fontsize',18);
set(hAx(1),'YTick',[0:50:200],'fontsize',18);
set(hAx(1),'YTickLabel',[0:50:200],'fontsize',18);
set(hAx(2),'YLim',[0 150],'fontsize',18);
set(hAx(2),'YTick',[0:30:150],'fontsize',18);
set(hAx(2),'YTickLabel',[0:30:150],'fontsize',18);
set(hAx(2),'Ycolor','k')
legend('E','\phi','Location','East');

%irf_legend(gca,'(c1)',[-0.15 1.03],'fontsize',20,'color','k')
text(-600/871-0.04,100,'o','color','r','fontsize',18)
text(-300/871-0.04,100,'o','color','r','fontsize',18)
text(-000/871-0.04,100,'o','color','r','fontsize',18)
end
end